<template>
  <div>
    <template v-if="isPurchased">
      <lesson-content :lesson="lesson"/>
    </template>
    <template v-else>
      <v-container>
        <v-row dense>
          <v-col cols="12">
            <v-card>
              <v-card-title color="primary">
                Получите доступ!
              </v-card-title>
              <v-card-text>
                <p class="white--text">
                  Для того что бы получить доступ к уроку приобретите курс <b>{{ course.name }}</b> за <b>{{ course.price.toLocaleString() }}</b> рублей
                </p>
              </v-card-text>
              <course-list-item :course="course">
                <template slot="button">
                  <v-btn color="primary" block small @click="pay">Купить</v-btn>
                </template>
              </course-list-item>
            </v-card>
          </v-col>
        </v-row>
      </v-container>
    </template>
  </div>
</template>

<script lang="ts">

import Vue from "vue";
import Component from "vue-class-component";
import { Lesson } from "@/domain/entity/lesson/Lesson";
import { Prop } from "vue-property-decorator";
import LessonContent from "./LessonContent.vue";
import { PurchaseCourse } from "@/domain/entity/purchase/course/PurchaseCourse";
import { Course } from "@/domain/entity/course/Course";
import CourseListItem from "@/components/courses/CourseListItem.vue";
import { AuthInfoResponse } from "@/domain/response/auth/info/AuthInfoResponse";
import { PurchasePayForm } from "@/domain/form/purchase/PurchasePayForm";

@Component({
  components: {
    LessonContent,
    CourseListItem
  }
})
export default class LessonContentPurchase extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly lesson!: Lesson;

  @Prop({
    required: false,
    type: Array,
    default: () => []
  })
  private readonly purchases!: PurchaseCourse[];

  @Prop({
    required: true,
    type: Object
  })
  private readonly course!: Course;

  private get isPurchased (): boolean {
    return this.purchases.some(item => item.isPaid && item.courseId === this.lesson.courseId);
  }

  private get userId (): string {
    const info: AuthInfoResponse|null = this.$store.getters['auth/info'];
    if (!info) {
      return "";
    }
    return info.id;
  }

  public async pay (): Promise<void> {
    await this.$store.dispatch("purchasesCourse/pay", new PurchasePayForm(
      this.lesson.courseId,
      this.userId
    ));
  }
}

</script>

<style scoped>

</style>
